frontend/main/routes/compras.py
from flask import Blueprint, render_template, redirect, url_for, current_app, request, flash
from flask_login import login_required, LoginManager, current_user
from .. formularios.compra import FormFilterCompra
import requests, json
from .auth import admin_required, cliente_required


compras = Blueprint('compras', __name__, url_prefix='/compras')


@compras.route('/ver/<int:id>')
@login_required
@admin_required
def ver(id):
    user = current_user
    auth = request.cookies['access_token']
    headers = {
            'content-type': "application/json",
            'authorization': "Bearer "+auth}
    r = requests.get(
            current_app.config['API_URL']+'/compra/'+str(id),
            headers = headers)
    if (r.status_code == 404):
        return redirect(url_for('compras.ver_todas'))
    compra = json.loads(r.text)
    print(compra)
    return render_template('ver_modificar_compra.html', compra = compra, user = user)

@compras.route('/todas')
@login_required
@admin_required
def ver_todas():
    filter = FormFilterCompra(request.args, meta={'csrf': False})
    data = {}
    data['page'] = 1
    data['per_page'] = 10
    if 'page' in request.args:
        data['page'] = request.args.get('page','')
    auth = request.cookies['access_token']
    headers = {
            'content-type': "application/json",
            'authorization': "Bearer "+auth}
    
    if filter.envio():
        if filter.nombre.data != None:
            data['nombre'] = filter.nombre.data
        if filter.apellido.data != None:
            data['apellido'] = filter.apellido.data
        if filter.retirado != None:
            data['retirado'] = filter.retirado.data
        if filter.ordenamiento.data != None:
            data['ordenamiento'] = filter.ordenamiento.data

    r = requests.get(
            current_app.config['API_URL']+'/compras',
            headers = headers,
            data = json.dumps(data))
    compras = json.loads(r.text)["compras"]
    pagination = {}
    pagination["pages"] = json.loads(r.text)["pages"]
    pagination["current_page"] = json.loads(r.text)["page"]
    return render_template('compras_admin.html', compras = compras, pagination = pagination, filter = filter)

@compras.route('comprar/<int:id>')
@login_required
@cliente_required
def comprar(id):
    auth = request.cookies['access_token']
    headers = {
            'content-type': 'application/json',
            'authorization': 'Bearer '+auth}
    data = {}
    data["bolsonid"] = id
    r = requests.post(
            current_app.config['API_URL']+'/compras',
            headers = headers,
            data = json.dumps(data))
    if (r.status_code == 201):
        flash('Compra exitosa.', 'success')
        return redirect(url_for('main.index'))
    return render_template('main.index')

@compras.route('mis-compras')
@login_required
@cliente_required
def mis_compras():
    data = {}
    data['page'] = 1
    data['per_page'] = 10
    if 'page' in request.args:
        data['page'] = request.args.get('page','')
    auth = request.cookies['access_token']
    headers = {
            'content-type': 'application/json',
            'authorization': 'Bearer '+auth}

    r = requests.get(
            current_app.config['API_URL']+'/compras',
            headers = headers,
            data=json.dumps(data))
    compras = json.loads(r.text)["compras"]
    pagination = {}
    pagination['pages'] = json.loads(r.text)['pages']
    pagination['current_page'] = json.loads(r.text)['page']
    return render_template('mis_compras.html', compras = compras, pagination = pagination)

@compras.route('retirado/<int:id>')
@login_required
@admin_required
def retirado(id):
    auth = request.cookies['access_token']
    headers = {
            'content-type': 'application/json',
            'authorization': 'Bearer '+auth}
    data = {}
    data['retirado'] = 1
    r = requests.put(
            current_app.config['API_URL']+'/compra/'+str(id),
            headers = headers,
            data = json.dumps(data))
    if (r.status_code == 201):
        flash('Compra retirada.', 'success')
    return redirect(url_for('compras.ver_todas'))

@compras.route('no-retirado/<int:id>')
@login_required
@admin_required
def no_retirado(id):
    auth = request.cookies['access_token']
    headers = {
            'content-type': 'application/json',
            'authorization': 'Bearer '+auth}
    data = {}
    data['retirado'] = 0
    r = requests.put(
            current_app.config['API_URL']+'/compra/'+str(id),
            headers = headers,
            data = json.dumps(data))
    if (r.status_code == 201):
        flash('Compra no retirada.', 'warning')
    return redirect(url_for('compras.ver_todas'))

@compras.route('/eliminar/<int:id>')
@login_required
@admin_required
def eliminar(id):
    auth = request.cookies['access_token']
    headers = {
            'content-type': 'application/json',
            'authorization': 'Bearer '+auth}
    r = requests.delete(
            current_app.config['API_URL']+'/compra/'+str(id),
            headers = headers)
    if r.status_code == 404:
        flash('Compra no encontrada.', 'danger')
    else:
        flash('Compra eliminada.', 'success')
    return redirect(url_for('compras.ver_todas'))

frontend/main/routes/productos.py
from flask import Blueprint, url_for, render_template, redirect, current_app, request, flash
from .. formularios.producto import FormProducto, FormFilterProducto
from flask_login import login_required, current_user, LoginManager
import requests, json
from .auth import admin_required, proveerdor_required, admin_provider_required


productos = Blueprint('productos', __name__, url_prefix='/productos')


@productos.route('/ver/<int:id>')
def ver(id):
    user = current_user
    r = requests.get(
            current_app.config['API_URL']+'/producto/'+str(id),
            headers = {"content-type": "application/json"})
    if (r.status_code == 404):
        return redirect(url_for('main.index'))
    producto = json.loads(r.text)
    return render_template('producto.html', producto = producto, user = user)

@productos.route('/todos')
@login_required
@admin_provider_required
def ver_todos():
    filter = FormFilterProducto(request.args, meta={'csrf': False})
    data = {}
    data['page'] = 1
    data['per_page'] = 10
    if 'page' in request.args:
        data["page"] = request.args.get('page','')
    auth = request.cookies['access_token']
    headers = {
            'content-type': "application/json",
            'authorization': "Bearer "+auth}
    
    data_prov = {}
    data_prov['page'] = 1
    r = requests.get(
            current_app.config['API_URL']+'/proveedores',
            headers = headers,
            data = json.dumps(data_prov))
    proveedores = [(item['id'], item['nombre']+" "+item['apellido']) for item in json.loads(r.text)["proveedores"]]
    proveedores.insert(0, (0, "Proveedor"))
    filter.proveedorid.choices = proveedores

    if filter.envio():
        if filter.proveedorid.data != None and filter.proveedorid.data != 0:
            data["proveedorid"] = filter.proveedorid.data
        if filter.ordenamiento.data != None:
            data["ordenamiento"] = filter.ordenamiento.data

    r = requests.get(
            current_app.config['API_URL']+'/productos',
            headers=headers,
            data = json.dumps(data))
    productos = json.loads(r.text)["productos"]
    pagination = {}
    pagination["pages"] = json.loads(r.text)["pages"]
    pagination["current_page"] = json.loads(r.text)["page"]
    return render_template('productos_admin.html', productos=productos, pagination=pagination, filter=filter)

@productos.route('/crear', methods=['POST', 'GET'])
@proveerdor_required
def crear():
    form = FormProducto()

    if form.validate_on_submit():
        auth = request.cookies['access_token']
        headers = {'content-type': 'application/json',
                'authorization': 'Bearer '+auth}
        data = {}
        data["nombre"] = form.nombre.data
        data["descripcion"] = form.descripcion.data
        r = requests.post(
                current_app.config['API_URL']+'/productos',
                headers = headers,
                data = json.dumps(data))
        if (r.status_code == 201):
            flash('Producto creado.','success')
            return redirect(url_for('productos.ver_todos'))
    return render_template('crear_producto.html', formulario=form)

@productos.route('/eliminar/<int:id>')
@admin_provider_required
def eliminar(id):
    auth = request.cookies['access_token']
    headers = {
            'content-type': 'application/json',
            'authorization': 'Bearer '+auth}
    r = requests.delete(
            current_app.config['API_URL']+'/producto/'+str(id),
            headers = headers)
    if (r.status_code == 204):
        flash('Producto eliminado.', 'success')
    elif (r.status_code == 404):
        flash('Producto no encontrado', 'danger')
    elif (r.status_code == 405):
        flash('No se puede eliminar el producto porque permanece a un bolson en venta.', 'warning')
    return redirect(url_for('productos.ver_todos'))

frontend/main/routes/proveedor.py
from flask import Blueprint, render_template, redirect, url_for, current_app, request, flash
from .. formularios.registrarse import FormRegistro
from .. formularios.proveedores import FormFilterProveedor
from flask_login import login_required, LoginManager, current_user
import requests, json
from .auth import admin_required, proveerdor_required


proveedores = Blueprint('proveedores', __name__, url_prefix='/proveedores')


@proveedores.route('/registrar', methods=['POST', 'GET'])
@login_required
@admin_required
def registrar():
    form = FormRegistro()
    if form.validate_on_submit():
        data = {}
        data["nombre"] = form.nombre.data
        data["apellido"] = form.apellido.data
        data["email"] = form.email.data
        data["telefono"] = form.telefono.data
        data["password"] = form.password.data
        data["role"] = 'proveedor'
        headers = {"content-type": "application/json"}
        print(data)
        r = requests.post(
                current_app.config["API_URL"]+'/auth/register',
                headers = headers,
                data = json.dumps(data))
        flash('Proveedor creado.', 'success')
        return redirect(url_for('proveedores.ver_todos'))
    return render_template('crear_proveedor.html', formulario=form)

@proveedores.route('/ver/<int:id>')
def ver(id):
    user = current_user
    auth = request.cookies['access_token']
    headers = {
            'content-type': "application/json",
            'authorization': "Bearer "+auth}
    r = requests.get(
            current_app.config["API_URL"]+'/proveedor/'+str(id),
            headers = headers)
    if (r.status_code == 404):
        return redirect(url_for('proveedores.ver_todos'))
    proveedor = json.loads(r.text)
    return render_template('cliente.html', usuario = proveedor, user = user)


@proveedores.route('/todos')
@login_required
@admin_required
def ver_todos():
    filter = FormFilterProveedor(request.args, meta={'csrf': False})
    data = {}
    data['page'] = 1
    data['per_page'] = 10
    if 'page' in request.args:
        data['page'] = request.args.get('page','')
    auth = request.cookies['access_token']
    headers = {
            'content-type': "application/json",
            'authorization': "Bearer "+auth}
    if filter.envio():
        if filter.ordenamiento.data != None:
            data["ordenamiento"] =  filter.ordenamiento.data

    r = requests.get(
            current_app.config["API_URL"]+'/proveedores',
            headers = headers,
            data = json.dumps(data))
    proveedores = json.loads(r.text)["proveedores"]
    pagination = {}
    pagination["pages"] = json.loads(r.text)["pages"]
    pagination["current_page"] = json.loads(r.text)["page"]
    return render_template('proveedores_admin.html', proveedores = proveedores, pagination = pagination, filter = filter)

@proveedores.route('/eliminar/<int:id>')
@login_required
@admin_required
def eliminar(id):
    auth = request.cookies['access_token']
    headers = {
            'content-type': 'application/json',
            'authorization': 'Bearer '+auth}
    r = requests.delete(
            current_app.config['API_URL']+'/proveedor/'+str(id),
            headers = headers)
    if (r.status_code == 404):
        flash('Proveedor no encontrado.', 'danger')
        return redirect(url_for('proveedores.ver_todos'))
    flash('Proveedor eliminado.', 'success')
    return redirect(url_for('proveedores.ver_todos'))

frontend/main/templates/macros/bolson.html
{% macro ver_bolson(bolson, user) %}
{#% from "macros/form_macros.html" import MostrarCampo, MostrarEnvio %#}
<div class="col-md-5 col-sm-1 d-flex p-2 bd-highlight">
  <div>
    <ul class="list-unstyled">
      <li class="p-2">
        <img class="img-fluid" src="https://via.placeholder.com/100x100">
      </li>
      <li class="p-2">
        <img class="img-fluid" src="https://via.placeholder.com/100x100">
      </li>
      <li class="p-2">
        <img class="img-fluid" src="https://via.placeholder.com/100x100">
      </li>
    </ul>
  </div>
  <div class="p-2">
    <img class="img-fluid" src="https://via.placeholder.com/400x400">
  </div>
</div>
<div class="col-md-3 col-sm-1 d-flex p-2 bd-highlight">
    <div>
      <h3>{{bolson.nombre}}</h3>
      <h1>{{bolson.precio}}</h1>
      <h5>Productos que contiene:</h5>
      {% if bolson.productos %}
        <table class="table align-middle">
          <thead>
            <tr>
              <th scope="col"></th>
              <th scope="col"></th>
              <th scope="col"></th>
            </tr>
          </thead>
          <tbody>
            {% for producto in bolson.productos %}
              <tr>
                <th>{{producto.nombre}}</th>
                <td>Cantidad: 1</td>
                <td><a type="button" class="btn btn-primary" href="{{url_for('productos.ver', id=producto.productoid)}}">Ver</a></td>
              </tr>
            {% endfor %}
          </tbody>
        </table>
      {% endif %}
      <div>
        <p>{{bolson.fecha}}</p> 
      </div>
      <div class="d-flex justify-content-center m-2">
        {% if user.is_authenticated and user.role == 'admin' %}
          {% if bolson.aprobado %}
            <a type="button" class="btn btn-danger m-2" href="{{url_for('bolsones.desaprobar', id=bolson.id)}}">Desaprobar</a>
          {% else %}
            <a type="button" class="btn btn-success m-2" href="{{url_for('bolsones.aprobar', id=bolson.id)}}">Aprobar</a>
          {% endif %}
        {% else %}
          <a type="button" class="btn btn-primary m-2" href="{{url_for('compras.comprar', id=bolson.id)}}">Comprar</a>
        {% endif %}
        <button class="btn btn-primary m-2" type="button" onclick="history.back()">Volver</button>
      </div>
    </div>
</div>
{% endmacro %}

{% macro mostrar_card_bolson(bolson) %}
{% if bolson.aprobado %}
<div class="col-md-2 col-sm-6 pt-3">
  <div class="card">
    <img src="https://via.placeholder.com/100x100" class="card-img-top" alt="imagen bolson">
    <div class="card-body">
      <h5 class="card-title">{{bolson.nombre}}</h5>
      <p class="card-text">{{bolson.precio}}</p>
        <div class="d-grid gap-2">
          <a href="{{url_for('bolsones.ver_en_venta', id=bolson.id)}}" class="btn btn-primary">Ver</a>
        </div>
    </div>
  </div>
</div>
{% endif %}
{% endmacro %}

{% macro bolsones(bolson, user) %}
<tr>
  <th>{{bolson.nombre}}</th>
  <td>{{bolson.fecha}}</td>
  {% if bolson.aprobado %}
  <td style="color:green">Si</td>
  {% else %}
  <td style="color:red">No</td> 
  {% endif %}
  <td>{{bolson.precio}}</td>
  {% if user.is_authenticated and user.role == 'admin' %}
  <td><a href="{{url_for('bolsones.ver', id=bolson.id)}}" class="btn btn-primary">Ver</a></td>
  {% else %}
  <td><a href="{{url_for('bolsones.ver_pendiente', id=bolson.id)}}" class="btn btn-primary">Ver</a></td>
  {% endif %}
</tr>
{% endmacro %}

{% macro pendientes(bolson) %}
<tr>
  <th>{{bolson.nombre}}</th>
  <td>{{bolson.fecha}}</td>
  <td style="color:red">No</td>
  <td>{{bolson.precio}}</td>
  <td><a href="{{url_for('bolsones.ver_pendiente', id=bolson.id)}}" class="btn btn-primary">Ver</a></td>
  <td>
    <button type="button" class="btn btn-danger" data-bs-toggle="modal" data-bs-target="#bolson{{bolson.id}}">
      Eliminar
    </button>
    <div class="modal fade" id="bolson{{bolson.id}}" tabindex="-1" aria-labelledby="exampleModalLabel" aria-hidden="true">
      <div class="modal-dialog modal-dialog-centered">
        <div class="modal-content">
          <div class="modal-header">
            <h5 class="modal-title" id="exampleModalLabel">Eliminar bolsón</h5>
          </div>
          <div class="modal-body">
            ¿Está seguro que quiere eliminar el bolsón?
          </div>
          <div class="modal-footer">
            <a type="button" class="btn btn-danger" href="{{url_for('bolsones.eliminar', id=bolson.id)}}">Eliminar</a> 
            <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Cancelar</button>
          </div>
        </div>
      </div>
  </td>
</tr>
{% endmacro %}

frontend/main/templates/macros/compras.html
{% macro ver_compra(compra, user) %}
<div style="padding: 30px">
  <h3>Datos compra #{{compra.id}}</h3>
  <form>
    <div class="row mb-3">
      <div class="col d-flex justify-content-center p-2">
        <img class="img-fluid" src="http://via.placeholder.com/400x400">
      </div>
      <div class="col p-2">
        <p><b>Bolsón:</b> {{compra.bolson}}</p>
        <p><b>Cliente:</b> {{compra.cliente}}</p>
        <p><b>Fecha:</b> {{compra.fechaHoraCompra}}</p>
        <p><b>Precio:</b> ${{compra.precio}}</p>
        <div class="d-flex">
          <div class="d-flex">
            <p><b>Aprobado: </b></p>
              {% if compra.retirado %}
              <p style="color:green">Si</p>
              {% else %}
              <p style="color:red">No</p>
              {% endif %}
          </div>
        </div>
      </div>
    </div>
    <div class="row mb-3">
      <div class="col d-flex justify-content-end mt-4">
            {% if user.is_authenticated and user.role == 'admin' %}
            {% if compra.retirado %}
            <a type="button" class="btn btn-danger m-1" href="{{url_for('compras.no_retirado', id=compra.id)}}">Marcar sin retirar</a>
            {% else %}
            <a type="button" class="btn btn-success m-1" href="{{url_for('compras.retirado', id=compra.id)}}">Marcar retirado</a>
            {% endif %}
            {% endif %}
        <button class="btn btn-primary m-1" type="button" onclick="history.back()">Volver</button>
      </div>
    </div>
  </form>
</div>
{% endmacro %}

{% macro compras(compra) %}
<tr>
  <td>{{compra.id}}</td>
  <td>{{compra.fechaHoraCompra}}</td>
  <td>{{compra.cliente}}</td>
  {% if compra.retirado %}
  <td style="color:green">Si</td>
  {% else %}
  <td style="color:red">No</td> 
  {% endif %}
  <td><a href="{{url_for('compras.ver', id=compra.id)}}" class="btn btn-primary">Ver</a></td>
  <td>
    <button type="button" class="btn btn-danger" data-bs-toggle="modal" data-bs-target="#compra{{compra.id}}">
      Eliminar
    </button>
    <div class="modal fade" id="compra{{compra.id}}" tabindex="-1" aria-labelledby="exampleModalLabel" aria-hidden="true">
      <div class="modal-dialog modal-dialog-centered">
        <div class="modal-content">
          <div class="modal-header">
            <h5 class="modal-title" id="exampleModalLabel">Eliminar compra</h5>
          </div>
          <div class="modal-body">
            ¿Está seguro que quiere eliminar el compra?
          </div>
          <div class="modal-footer">
            <a href="{{url_for('compras.eliminar', id=compra.id)}}" class="btn btn-danger">Eliminar</a>
            <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Cancelar</button>
          </div>
        </div>
      </div>
    </div>
  </td>
</tr>
{% endmacro %}

{% macro mis_compras(compra) %}
<tr>
  <th>{{compra.id}}</th>
  <td>{{compra.bolson}}</td>
  <td>{{compra.fechaHoraCompra}}</td>
  {% if compra.retirado %}
  <td style="color:green">Si</td>
  {% else %}
  <td style="color:red">No</td>
  {% endif %}
  <td>${{compra.precio}}</td>
</tr>
{% endmacro %}

frontend/main/templates/macros/form_macros.html
{% macro MostrarCampo(Campo) %}
{{Campo.label}}
{{Campo(**kwargs)}}
{{MostrarError(Campo)}}
{% endmacro %}

{% macro MostrarEnvio(Campo) %}
{{Campo(**kwargs)|safe}}
{% endmacro %}

{% macro MostrarError(Campo) %}
{% if Campo.errors %}
{% for error in Campo.errors %}
<span style="color:red">{{error}}</span><br/>
{% endfor %}
{% endif %}
{% endmacro %}

frontend/main/templates/macros/producto.html
{% macro ver_producto(producto, user) %}
<div class="col-md-4 col-sm-1 d-flex justify-content-center p-2 bd-highlight">
  <div class="p-2">
    <img class="img-fluid" src="https://via.placeholder.com/400x400">
  </div>
</div>
<div class="col-md-4 col-sm-1 d-flex p-2 bd-highlight">
  <div class="row">
    <div>
      <h3>{{producto.nombre}}</h3>
      <h6>Descripción:</h6>
      <p>{{producto.descripcion}}</p
      <div>
        <p>
          <b>Proveedor: </b>
          {% if user.role == 'admin' %}
          <a style="color: #000; text-decoration: none" href="{{url_for('usuarios.proveedor', id=producto.proveedorid)}}">{{producto.proveedor}}</a>
          {% else %}
          <a style="color: #000; text-decoration: none" href="{{url_for('proveedores.ver', id=producto.proveedorid)}}">{{producto.proveedor}}</a>
          {% endif %}
        </p>
      </div>
    </div>
    <div class="row">
      <div class="d-flex align-self-end justify-content-end m-2">
        <button class="btn btn-primary m-2" type="button" onclick="history.back()">Volver</button>
      </div>
    </div>
  </div>
</div>
{% endmacro %}

{% macro productos(producto) %}
<tr>
  <td>{{producto.nombre}}</td>
  <td>{{producto.proveedor}}</td>
  <td><a href="{{url_for('productos.ver', id=producto.id)}}" class="btn btn-primary">Ver</a></td>
  <td>
    <button type="button" class="btn btn-danger" data-bs-toggle="modal" data-bs-target="#producto{{producto.id}}">
      Eliminar
    </button>
    <div class="modal fade" id="producto{{producto.id}}" tabindex="-1" aria-labelledby="exampleModalLabel" aria-hidden="true">
      <div class="modal-dialog modal-dialog-centered">
        <div class="modal-content">
          <div class="modal-header">
            <h5 class="modal-title" id="exampleModalLabel">Eliminar producto</h5>
          </div>
          <div class="modal-body">
            ¿Está seguro que quiere eliminar el producto?
          </div>
          <div class="modal-footer">
            <a href="{{url_for('productos.eliminar', id=producto.id)}}" class="btn btn-danger">Eliminar</a>
            <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Cancelar</button>
          </div>
        </div>
      </div>
  </td>
</tr>
{% endmacro %}